Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPJob.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPJob.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPJob.cs	(revision 6177)
@@ -33,11 +33,9 @@
   [Item("Job Class", "Represents a composition of tasks that require processing in a job shop scheduling problem.")]
   [StorableClass]
-  public class JSSPJob : ParameterizedNamedItem {
+  public class JSSPJob : IndexedTaskList {
     [StorableConstructor]
     protected JSSPJob(bool deserializing) : base(deserializing) { }
     protected JSSPJob(JSSPJob original, Cloner cloner)
       : base(original, cloner) {
-      this.JobIndex = cloner.Clone(original.JobIndex);
-      this.Tasks = cloner.Clone(original.Tasks);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -45,39 +43,10 @@
     }
 
-    #region Parameter Properties
-    public ValueParameter<IntValue> JobIndexParameter {
-      get { return (ValueParameter<IntValue>)Parameters["JobIndex"]; }
-    }
-
-    public ValueParameter<ItemList<Task>> TasksParameter {
-      get { return (ValueParameter<ItemList<Task>>)Parameters["Tasks"]; }
-    }
-    #endregion
-
-    #region Properties
-    public IntValue JobIndex {
-      get { return JobIndexParameter.Value; }
-      set { JobIndexParameter.Value = value; }
-    }
-    public ItemList<Task> Tasks {
-      get { return TasksParameter.Value; }
-      set { TasksParameter.Value = value; }
-    }
-    #endregion
-
-
-    public JSSPJob(IntValue ji) {
-      Parameters.Add(new ValueParameter<IntValue>("JobIndex", "The index of the job in the associated JSSP-Instance.", new IntValue()));
-      Parameters.Add(new ValueParameter<ItemList<Task>>("Tasks", "Taskdata defining duration, start-time and resource assignment of the tasks.", new ItemList<Task>()));
-
-      JobIndex = ji;
-      Tasks = new ItemList<Task>();
-    }
-
+    public JSSPJob(IntValue index) : base (index) {}
 
     public override string ToString() {
       StringBuilder sb = new StringBuilder();
-      sb.Append("Job" + JobIndex + " [ ");
-      foreach (Task t in Tasks) {
+      sb.Append("Job#" + Index + " [ ");
+      foreach (JSSPTask t in Tasks) {
         sb.Append(t.ToString () + " ");
       }
@@ -85,5 +54,4 @@
       return sb.ToString();
     }
-
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPTask.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPTask.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPTask.cs	(revision 6177)
@@ -32,11 +32,17 @@
   [Item("Job Shop Scheduling Task Class", "Represents smallest unit for a job shop scheduling problem.")]
   [StorableClass]
-  public class JSSPTask : Task {
+  public class JSSPTask : Item {
     [StorableConstructor]
     protected JSSPTask(bool deserializing) : base(deserializing) { }
     protected JSSPTask(JSSPTask original, Cloner cloner)
       : base(original, cloner) {
+      this.ResourceNr = cloner.Clone(original.ResourceNr);
+      this.Duration = cloner.Clone(original.Duration);
+      this.StartTime = cloner.Clone(original.StartTime);
+      this.TaskNr = cloner.Clone(original.TaskNr);
+      this.IsScheduled = cloner.Clone(original.IsScheduled);
       this.Job = cloner.Clone(original.Job);
       this.PreviousTask = cloner.Clone(original.PreviousTask);
+      this.NextTask = cloner.Clone(original.NextTask);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -45,9 +51,24 @@
 
 
+    public BoolValue IsScheduled { get; set; }
+    public IntValue TaskNr { get; set; }
+    public IntValue ResourceNr { get; set; }
+    public DoubleValue Duration { get; set; }
+    public DoubleValue StartTime { get; set; }
+    public DoubleValue EndTime {
+      get {
+        return new DoubleValue(Duration.Value + StartTime.Value);
+      }
+    }
+    public JSSPJob Job { get; set; }
+    public JSSPTask PreviousTask { get; set; }
+    public JSSPTask NextTask { get; set; }
 
-    public JSSPJob Job { get; set; }
-    public Task PreviousTask { get; set; }
-
-    public JSSPTask (IntValue taskNr, IntValue resNr, DoubleValue duration, JSSPJob j) : base (taskNr, resNr, duration) {
+    public JSSPTask (IntValue taskNr, IntValue resNr, DoubleValue duration, JSSPJob j) : base () {
+      Duration = duration;
+      ResourceNr = resNr;
+      TaskNr = taskNr;
+      StartTime = new DoubleValue(0);
+      IsScheduled = new BoolValue(false);
       Job = j;
     }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs	(revision 6177)
@@ -41,4 +41,6 @@
 using HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix.Crossovers;
 using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
 
 namespace HeuristicLab.Problems.Scheduling {
@@ -52,4 +54,6 @@
       : base(original, cloner) {
         operators = original.operators.Select(x => (IOperator)cloner.Clone(x)).ToList();
+        this.encodingType = original.encodingType;
+        AttachEventHandlers();
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -59,25 +63,18 @@
 
     #region Parameter Properties
-    public ValueParameter<IntValue> NrOfResourcesParameter {
-      get { return (ValueParameter<IntValue>)Parameters["NrOfResources"]; }
-    }
     public ValueParameter<ItemList<JSSPJob>> JobsParameter {
       get { return (ValueParameter<ItemList<JSSPJob>>)Parameters["Jobs"]; }
     }
-    public OptionalValueParameter<JSSPEncoding> BestKnownSolutionParameter {
-      get { return (OptionalValueParameter<JSSPEncoding>)Parameters["BestKnownSolution"]; }
+    public OptionalValueParameter<Schedule> BestKnownSolutionParameter {
+      get { return (OptionalValueParameter<Schedule>)Parameters["BestKnownSolution"]; }
     }
     #endregion
 
     #region Properties
-    public IntValue NrOfResources {
-      get { return NrOfResourcesParameter.Value; }
-      set { NrOfResourcesParameter.Value = value; }
-    }
     public ItemList<JSSPJob> Jobs {
       get { return JobsParameter.Value; }
       set { JobsParameter.Value = value; }
     }
-    public JSSPEncoding BestKnownSolution {
+    public Schedule BestKnownSolution {
       get { return BestKnownSolutionParameter.Value; }
       set { BestKnownSolutionParameter.Value = value; }
@@ -89,24 +86,47 @@
     private List<IOperator> operators;
 
+    [Storable]
+    private JSSPEncodingTypes encodingType;
 
     public JobShopSchedulingProblem()
-      : base(new MakespanEvaluator (), new JSMRandomCreator ()) {
-        Parameters.Add(new ValueParameter<IntValue>("NrOfResources", "Number of Resources used in this JSSP-Instance.", new IntValue()));
+      : base(new SchedulingEvaluator (), new JSMRandomCreator ()) {
         Parameters.Add(new ValueParameter<ItemList<JSSPJob>>("Jobs", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance.", new ItemList<JSSPJob>()));
-        Parameters.Add(new OptionalValueParameter<JSSPEncoding>("BestKnownSolution", "The best known solution of this JSSP instance."));
-
+        Parameters.Add(new OptionalValueParameter<Schedule>("BestKnownSolution", "The best known solution of this JSSP instance.")); 
+        encodingType = JSSPEncodingTypes.JSMEncoding;
         InitializeOperators();
+        AttachEventHandlers();
     }
 
     #region Events
     //TODO: Implement event handlers for problem specific events!
+    protected override void OnSolutionCreatorChanged() {
+      if (SolutionCreator.GetType().Equals(typeof(JSMRandomCreator)))
+        encodingType = JSSPEncodingTypes.JSMEncoding;
+      else
+        encodingType = JSSPEncodingTypes.PRVEncoding;
+
+      InitializeOperators();
+    }
     #endregion
 
     #region Helpers
     private void InitializeOperators() {
-      Operators.AddRange(ApplicationManager.Manager.GetInstances<IJSMOperator>());
+      Operators.Clear();
+      ApplyEncoding();
       Operators.Add(new BestSchedulingSolutionAnalyzer());
       //ParameterizeAnalyzer();
       //ParameterizeOperators();
+    }
+
+    private void ApplyEncoding() {
+      if (encodingType == JSSPEncodingTypes.JSMEncoding) {
+        Operators.AddRange(ApplicationManager.Manager.GetInstances<IJSMOperator>());
+        ((SchedulingEvaluator)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<JSMEncoding>(new JSMDecoder(), new MakespanEvaluator());
+      } else {
+        if (encodingType == JSSPEncodingTypes.PRVEncoding) {
+          Operators.AddRange(ApplicationManager.Manager.GetInstances<IPRVOperator>());
+          ((SchedulingEvaluator)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<PRVEncoding>(new PRVDecoder(), new MakespanEvaluator());
+        }
+      }
     }
 
@@ -148,8 +168,10 @@
         string line = problemFile.ReadLine();
         List<string> data = SplitString(line);
-        int taskCount = 0;
         if (data.Count > 0 && ((int)data[0][0] >= 48 && (int)data[0][0] <= 57)) {
-          NrOfResources = new IntValue(Int32.Parse(data[1]));
           int jobCount = 0;
+          //data[0] = nrOfJobs
+          //data[1] = nrOfResources
+          if (data.Count > 2)
+            BestKnownQualityParameter.ActualValue = new DoubleValue(Double.Parse (data[2]));
           line = problemFile.ReadLine();
           data = SplitString(line);
@@ -157,8 +179,10 @@
             JSSPJob j = new JSSPJob(new IntValue(jobCount));
             for (int i = 0; i < data.Count; i++) {
-              JSSPTask t = new JSSPTask(new IntValue (taskCount), new IntValue(Int32.Parse(data[i])), new DoubleValue(Double.Parse(data[i + 1])), j);
-              taskCount++;
-              if (j.Tasks.Count > 0)
+              JSSPTask t = new JSSPTask(new IntValue (i / 2), new IntValue(Int32.Parse(data[i])), new DoubleValue(Double.Parse(data[i + 1])), j);
+              if (j.Tasks.Count > 0) {
                 t.PreviousTask = j.Tasks[j.Tasks.Count - 1];
+                j.Tasks[j.Tasks.Count - 1].NextTask = t;
+                t.StartTime = new DoubleValue (t.PreviousTask.EndTime.Value + 2);
+              }
               j.Tasks.Add(t);
               i++;
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Resource.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Resource.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Resource.cs	(revision 6177)
@@ -30,16 +30,12 @@
 using HeuristicLab.Common;
 
-//ATTENTION! This class may have lots of parallels with the HeuristicLab.Problems.Scheduling.JSSPJob class.
-
 namespace HeuristicLab.Problems.Scheduling {
   [Item("Resource Class", "Represents a resource used in scheduling problems.")]
   [StorableClass]
-  public class Resource : ParameterizedNamedItem {
+  public class Resource : IndexedTaskList {
     [StorableConstructor]
     protected Resource(bool deserializing) : base(deserializing) { }
     protected Resource(Resource original, Cloner cloner)
       : base(original, cloner) {
-      this.ResourceIndex = cloner.Clone(original.ResourceIndex);
-      this.Tasks = cloner.Clone(original.Tasks);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -47,22 +43,4 @@
     }
 
-    #region Parameter Properties
-    public ValueParameter<IntValue> ResourceIndexParameter {
-      get { return (ValueParameter<IntValue>)Parameters["ResourceIndex"]; }
-    }
-    public ValueParameter<ItemList<Task>> TasksParameter {
-      get { return (ValueParameter<ItemList<Task>>)Parameters["Tasks"]; }
-    }
-    #endregion
-
-    #region Properties
-    public IntValue ResourceIndex {
-      get { return ResourceIndexParameter.Value; }
-      set { ResourceIndexParameter.Value = value; }
-    }
-    public ItemList<Task> Tasks {
-      get { return TasksParameter.Value; }
-      set { TasksParameter.Value = value; }
-    }
     public DoubleValue TotalDuration {
       get {
@@ -73,20 +51,11 @@
       }
     }
-    #endregion
 
-
-    public Resource(IntValue ri) {
-      Parameters.Add(new ValueParameter<IntValue>("ResourceIndex", "The index of the resource in the associated Scheduling Problem.", new IntValue()));
-      Parameters.Add(new ValueParameter<ItemList<Task>>("Tasks", "Taskdata defining duration, start-time and resource assignment of the tasks.", new ItemList<Task>()));
-
-      ResourceIndex = ri;
-      Tasks = new ItemList<Task>();
-    }
-
+    public Resource(IntValue index) : base (index) { }
 
     public override string ToString() {
       StringBuilder sb = new StringBuilder();
-      sb.Append("Job" + ResourceIndex + " [ ");
-      foreach (Task t in Tasks) {
+      sb.Append("Resource#" + Index + " [ ");
+      foreach (JSSPTask t in Tasks) {
         sb.Append(t.ToString() + " ");
       }
@@ -94,5 +63,4 @@
       return sb.ToString();
     }
-
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Schedule.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Schedule.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Schedule.cs	(revision 6177)
@@ -35,5 +35,5 @@
   [Item("Schedule Class", "Represents the general solution for scheduling problems.")]
   [StorableClass]
-  public class Schedule : ParameterizedNamedItem{
+  public class Schedule : NamedItem{
     [StorableConstructor]
     protected Schedule(bool deserializing) : base(deserializing) { }
@@ -41,4 +41,5 @@
       : base(original, cloner) {
         this.Resources = cloner.Clone (original.Resources);
+        this.Quality = cloner.Clone(original.Quality);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -46,21 +47,16 @@
     }
 
+    [Storable]
+    public ItemList<Resource> Resources;
 
-    #region Parameter Properties
-    public ValueParameter<ItemList<Resource>> ResourcesParameter {
-      get { return (ValueParameter<ItemList<Resource>>)Parameters["Resources"]; }
+    [Storable]
+    public DoubleValue Quality {
+      get;
+      set;
     }
-    #endregion
-
-    #region Properties
-    public ItemList<Resource> Resources {
-      get { return ResourcesParameter.Value; }
-      set { ResourcesParameter.Value = value; }
-    }
-    #endregion
-
 
     public Schedule(IntValue nrOfResources) {
-      Parameters.Add(new ValueParameter<ItemList<Resource>>("Resources", "Taskdata defining duration, start-time and resource assignment of the tasks.", new ItemList<Resource>()));
+      Resources = new ItemList<Resource>();
+      Quality = new DoubleValue();
       for (int i = 0; i < nrOfResources.Value; i++) {
         Resources.Add(new Resource(new IntValue (i)));
@@ -68,24 +64,13 @@
     }
 
-
-    public event PropertyChangedEventHandler PropertyChanged;
-    private void OnPropertyChanged(string propertyName) {
-      var handler = PropertyChanged;
-      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
-    }
-
-
     public override string ToString() {
       StringBuilder sb = new StringBuilder();
       sb.Append("[ ");
-
       foreach (Resource r in Resources) {
         sb.Append(r.ToString () + " \n");
       }
-
       sb.Append("]");
       return sb.ToString();
     }
-
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/SchedulingProblem.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/SchedulingProblem.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/SchedulingProblem.cs	(revision 6177)
@@ -28,9 +28,10 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Common;
+using HeuristicLab.Problems.Scheduling.Interfaces;
 
 namespace HeuristicLab.Problems.Scheduling {
   [Item("Scheduling Problem", "Abstract class that represents a Scheduling Problem")]
   [StorableClass]
-  public abstract class SchedulingProblem : SingleObjectiveHeuristicOptimizationProblem<JSSPEvaluator, SchedulingCreator> {
+  public abstract class SchedulingProblem : SingleObjectiveHeuristicOptimizationProblem<ISchedulingEvaluator, ISchedulingCreator> {
     [StorableConstructor]
     protected SchedulingProblem(bool deserializing) : base(deserializing) { }
@@ -39,5 +40,5 @@
     }
 
-    protected SchedulingProblem (JSSPEvaluator se, SchedulingCreator sc) : base (se, sc) {}
+    protected SchedulingProblem (ISchedulingEvaluator se, ISchedulingCreator sc) : base (se, sc) {}
 
   }
